import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Mooborn.GasScale.Class";

GasScaleWin = class(Turbine.UI.Window);
function GasScaleWin:Constructor()
	Turbine.UI.Window.Constructor( self );

	self.settings = GasScaleWinLoadSettings();

	self:SetSize(159,113);
	self:SetPosition( self.settings.x, self.settings.y );
	self:SetBackColor(Turbine.UI.Color(0,0,0,0));

	self.dragging = false;
	self.move = true;
--	self.hidden = false;
	self.locked = true;
	self.loaded = false;

	self.upperlayer = Turbine.UI.Button();
	self.upperlayer:SetParent(self);
	self.upperlayer:SetPosition(0,0); 
	self.upperlayer:SetSize(self:GetWidth(),self:GetHeight());	
	self:SetButtonImg(settings.mode);
	self.upperlayer:SetBackground("Mooborn/GasScale/image/smaug_scale.tga");
    self.upperlayer:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
--    self.upperlayer:SetBackColorBlendMode(Turbine.UI.BlendMode.Normal);

	self.upperlayer.toSmaug = Turbine.UI.Button();
	self.upperlayer.toSmaug:SetParent(self.upperlayer);
	self.upperlayer.toSmaug:SetPosition(0,0); 
	self.upperlayer.toSmaug:SetSize(44,20);

	self.upperlayer.toSmaug.MouseClick = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left then
			settings.mode=1;
			self:SetScale(settings.mode);
		end
	end

	self.upperlayer.toLmt = Turbine.UI.Button();
	self.upperlayer.toLmt:SetParent(self.upperlayer);
	self.upperlayer.toLmt:SetPosition(77,0); 
	self.upperlayer.toLmt:SetSize(82,20);
--	self.upperlayer.toLmt:SetOpacity(0.00);
--	self.upperlayer.toLmt:SetBackColor(Turbine.UI.Color(0,0,0,0));

	self.upperlayer.toLmt.MouseClick = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left then
			settings.mode=2;
			self:SetScale(settings.mode);
		end
	end

	self.upperlayer.MouseClick = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Right then
			self:SetWantsUpdates(false);
			self:SetWantsKeyEvents(true);
			self:SetVisible(false);
			self:SaveSettings();
			self:Close();
		end
	end

	self.cursor = Turbine.UI.Button();
	self.cursor:SetParent(self);
	self.cursor:SetPosition(0,0); 
	self.cursor:SetSize(self:GetWidth(),self:GetHeight());	
	self.cursor:SetBackground("Mooborn/GasScale/image/cursor.tga");

	self.cursor.arrowup = Turbine.UI.Button();
	self.cursor.arrowup:SetParent(self.cursor);
	self.cursor.arrowup:SetPosition(72,31); 
	self.cursor.arrowup:SetSize(21,22);

	self.cursor.arrowup.MouseClick = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left then
			local x, y = self:GetPosition();
			y=y-1;
			if y < 0 then y=0 end;
			settings.y = y;
			self:SetPosition(x, y);
		end
	end

	self.cursor.arrowdown = Turbine.UI.Button();
	self.cursor.arrowdown:SetParent(self.cursor);
	self.cursor.arrowdown:SetPosition(72,76); 
	self.cursor.arrowdown:SetSize(21,22);

	self.cursor.arrowdown.MouseClick = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left then
			local x, y = self:GetPosition();
			y=y+1;
			if y > (Turbine.UI.Display.GetHeight()-self:GetHeight()) then y = Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			settings.y = y;
			self:SetPosition(x, y);
		end
	end

	self.cursor.arrowleft = Turbine.UI.Button();
	self.cursor.arrowleft:SetParent(self.cursor);
	self.cursor.arrowleft:SetPosition(51,53); 
	self.cursor.arrowleft:SetSize(21,22);

	self.cursor.arrowleft.MouseClick = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left then
			local x, y = self:GetPosition();
			x=x-1;
			if x < 0 then x=0 end;
			settings.x = x;
			self:SetPosition(x, y);
		end
	end

	self.cursor.arrowright = Turbine.UI.Button();
	self.cursor.arrowright:SetParent(self.cursor);
	self.cursor.arrowright:SetPosition(94,53); 
	self.cursor.arrowright:SetSize(21,22);

	self.cursor.arrowright.MouseClick = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left then
			local x, y = self:GetPosition();
			x=x+1;
			if x > (Turbine.UI.Display.GetWidth()-self:GetWidth()) then x = Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			settings.x = x;
			self:SetPosition(x, y);
		end
	end

	self.cursor.MouseDown = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left and self.move then
			self.dragStartX = args.X;
			self.dragStartY = args.Y;
			self.dragging = true;
		end
	end

	self.cursor.MouseMove = function(sender,args)
		if self.dragging then
			local x, y = self:GetPosition();
			x = x + (args.X - self.dragStartX);
			y = y + (args.Y - self.dragStartY);
			if x < 0 then x=0 end;
			if x > (Turbine.UI.Display.GetWidth()-self:GetWidth()) then x = Turbine.UI.Display.GetWidth()-self:GetWidth() end;
			if y < 0 then y=0 end;
			if y > (Turbine.UI.Display.GetHeight()-self:GetHeight()) then y = Turbine.UI.Display.GetHeight()-self:GetHeight() end;
			settings.x = x;
			settings.y = y;
			self:SetPosition(x, y);
		end
	end

	self.cursor.MouseUp = function(sender,args)
		if args.Button == Turbine.UI.MouseButton.Left then
			self:SaveSettings();
			self.dragging = false;
		end
	end

	self.KeyDown = function(sender,args)
--		if (args.Action == 0x100000B3) then
--		    self.hidden = not self.hidden;
--			self:SetVisible(self.hidden); 

		if (args.Action == 0x1000007B) then
		    self.locked = not self.locked;
			self:CheckLocked();
		end
	end

	self:CheckLocked();
	self:SetWantsKeyEvents(true);

end

function GasScaleWin:SetButtonImg(mode)
	if mode==1 then
		self.upperlayer:SetBackground("Mooborn/GasScale/image/smaug_scale.tga");
	elseif mode==2 then
		self.upperlayer:SetBackground("Mooborn/GasScale/image/lm_scale.tga");
	else
		self.upperlayer:SetBackground("Mooborn/GasScale/image/smaug_scale.tga");
	end
end

function GasScaleWin:CheckLocked(args)
	if self.locked then
		self.upperlayer:SetVisible(true);
		self.upperlayer:SetEnabled(true);
		self.cursor:SetVisible(false);
		self.cursor:SetEnabled(false);
		self:SaveSettings();
	else
		self.upperlayer:SetVisible(false);
		self.upperlayer:SetEnabled(false);
		self.cursor:SetVisible(true);
		self.cursor:SetEnabled(true);
	end
end

function GasScaleWin:SetScale(mode)

	self:SetButtonImg(mode);

	if (mode==1) then
		self.upperlayer.toLmt:SetEnabled(true);
		self.upperlayer.toSmaug:SetEnabled(false);
	else
		self.upperlayer.toLmt:SetEnabled(false);
		self.upperlayer.toSmaug:SetEnabled(true);
	end
end

function GasScaleWinLoadSettings()
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "GasScale" );
	if type( settings ) ~= "table" then
		settings={ };
	end
	if (not settings.x) then settings.x = 200; end
	if (not settings.y) then settings.y = 200; end
	if (not settings.fixed) then settings.mode = 1; end

	return settings;
end

function GasScaleWin:SaveSettings()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "GasScale", self.settings );
end
